﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace TestApp
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnClick(object sender, RoutedEventArgs e)
        {
            rect.Width = 0d;
            /*
            Task taskrun = new Task(() =>
            {
                double i = 0d;
                for (i = 0d; i < 800d; i++)
                {
                    Task.Delay(5).Wait();
                    Action act = () => rect.Width++;
                    Dispatcher.BeginInvoke(act, DispatcherPriority.Render);
                }
            });
            taskrun.Start();
            */

            //Action invkAct = () =>
            //{
            //    rect.Width++;
            //};

            //for (double i = 0d; i< 800d; i++)
            //{
            //    Task.Delay(5).Wait();
            //    Dispatcher.BeginInvoke(invkAct, DispatcherPriority.Render);
            //}
            for (double n = 0d; n < 800d; n++)
            {
                Task.Delay(5).Wait();
                rect.Width++;
                ProcessMsgs();
            }
        }

        private void ProcessMsgs()
        {
            DispatcherFrame frame = new DispatcherFrame();
            Action<object> cb = obj =>
            {
                DispatcherFrame f = obj as DispatcherFrame;
                f.Continue = false;
            };
            Dispatcher.BeginInvoke(cb, DispatcherPriority.Background, frame);
            Dispatcher.PushFrame(frame);
        }
    }
}
